import 'dart:io';

import 'package:firebase_core/firebase_core.dart';
import 'package:firebase_messaging/firebase_messaging.dart';
import 'package:flutter/material.dart';
import 'package:flutter_secure_storage/flutter_secure_storage.dart';
import 'package:flutter_stripe/flutter_stripe.dart';
import 'package:get/get.dart';
import 'package:get_storage/get_storage.dart';
import 'package:flutter/services.dart';

import 'constant/api_key.dart';
import 'constant/credential.dart';
import 'constant/info.dart';
import 'controller/firebase/firbase_messge.dart';
import 'controller/local/local_controller.dart';
import 'controller/local/translations.dart';
import 'firebase_options.dart';
import 'models/db_sql.dart';
import 'splash_screen_page.dart';

final box = GetStorage();
const storage = FlutterSecureStorage();
DbSql sql = DbSql.instance;
@pragma('vm:entry-point')
Future<void> backgroundMessageHandler(RemoteMessage message) async {
  await Firebase.initializeApp();
  print('===========back===${message.notification?.title}');

  FirebaseMessagesController().firebasetitles(message);
}

void main() async {
  WidgetsFlutterBinding.ensureInitialized();
  await GetStorage.init();
  await AC().gAK();
  print(
      'local is t   ${WidgetsBinding.instance.platformDispatcher.locale.countryCode}');
  print(Get.deviceLocale!.countryCode);
  Stripe.publishableKey = AK.publishableKey;

  //StripeKey.publishableKey;
  if (Platform.isAndroid || Platform.isIOS) {
    await Firebase.initializeApp(
      options: DefaultFirebaseOptions.currentPlatform,
    );
    await FirebaseMessagesController().requestFirebaseMessagingPermission();

    FirebaseMessaging.onBackgroundMessage(backgroundMessageHandler);

    List<Future> initializationTasks = [
      FirebaseMessagesController().getNotificationSettings(),
      FirebaseMessagesController().getToken(),
    ];
    // cameras = await availableCameras();
    await Future.wait(initializationTasks);
    SystemChrome.setPreferredOrientations([
      DeviceOrientation.portraitUp,
      DeviceOrientation.portraitDown,
    ]);
  }

  runApp(const MyApp());
}

class MyApp extends StatelessWidget {
  const MyApp({super.key});

  // This widget is the root of your application.

  @override
  Widget build(BuildContext context) {
    LocaleController localController = Get.put(LocaleController());

    return GetMaterialApp(
        title: AppInformation.appName,
        translations: MyTranslation(),
        debugShowCheckedModeBanner: false,
        locale: localController.language,
        theme: localController.appTheme,
        key: UniqueKey(),
        // routes: {'/':const HomePage()},
        // home: LoginCaptin());
        home: SplashScreen());
  }
}
